SoGLTextureImageElement Class Reference

| http://www.sim.no/ http://www.coin3d.org/

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
SoGLTextureImageElement Class Reference
Element Classes

The SoGLTextureImageElement is used to control the current GL texture.This is a lazy element. It is evaluated in SoShape::shouldGLRender(). More...

`#include <Inventor/elements/SoGLTextureImageElement.h>`

Inheritance diagram for SoGLTextureImageElement:

## Public Member Functions
virtual void | init (SoState *state)
| FIXME: write doc.
virtual void | push (SoState *state)
virtual void | pop (SoState *state, const SoElement *prevTopElement)
virtual SbBool | isTextureSizeLegal (int xsize, int ysize, int zsize, int bytespertexel)
Public Member Functions inherited from SoReplacedElement
virtual SbBool | matches (const SoElement *element) const
virtual SoElement * | copyMatchInfo () const
uint32_t | getNodeId () const
virtual void | print (FILE *file) const
Public Member Functions inherited from SoElement
const SoType | getTypeId (void) const
int | getStackIndex (void) const
void | setDepth (const int depth)
int | getDepth (void) const
virtual | ~SoElement ()

## Static Public Member Functions
static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void * | createInstance (void)
static void | initClass (void)
static void | set (SoState *const state, SoNode *const node, SoGLImage *image, const Model model, const SbColor &blendColor)
static SoGLImage * | get (SoState *state, Model &model, SbColor &blendcolor)
static int32_t | getMaxGLTextureSize (void)
static SbBool | hasTransparency (SoState *state)
Static Public Member Functions inherited from SoTextureImageElement
static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void * | createInstance (void)
static void | initClass (void)
static void | setDefault (SoState *const state, SoNode *const node)
static void | set (SoState *const state, SoNode *const node, const SbVec2s &size, const int numComponents, const unsigned char *bytes, const int wrapS, const int wrapT, const int model, const SbColor &blendColor)
static void | set (SoState *const state, SoNode *const node, const SbVec3s &size, const int numComponents, const unsigned char *bytes, const int wrapS, const int wrapT, const int wrapR, const int model, const SbColor &blendColor)
static void | set (SoState *const state, SoNode *const node, const SbVec2s &size, const int numComponents, const unsigned char *bytes, const Wrap wrapS, const Wrap wrapT, const Model model, const SbColor &blendColor)
static void | set (SoState *const state, SoNode *const node, const SbVec3s &size, const int numComponents, const unsigned char *bytes, const Wrap wrapS, const Wrap wrapT, const Wrap wrapR, const Model model, const SbColor &blendColor)
static const unsigned char * | get (SoState *const state, SbVec2s &size, int &numComponents, Wrap &wrapS, Wrap &wrapT, Model &model, SbColor &blendColor)
| FIXME: write doc.
static const unsigned char * | get (SoState *const state, SbVec3s &size, int &numComponents, Wrap &wrapS, Wrap &wrapT, Wrap &wrapR, Model &model, SbColor &blendColor)
static const unsigned char * | get (SoState *const state, SbVec2s &size, int &numComponents, int &wrapS, int &wrapT, int &model, SbColor &blendColor)
static const unsigned char * | get (SoState *const state, SbVec3s &size, int &numComponents, int &wrapS, int &wrapT, int &wrapR, int &model, SbColor &blendColor)
static const SbColor & | getBlendColor (SoState *const state)
static const unsigned char * | getImage (SoState *const state, SbVec2s &size, int &numComponents)
static const unsigned char * | getImage (SoState *const state, SbVec3s &size, int &numComponents)
static Model | getModel (SoState *const state)
static Wrap | getWrapS (SoState *const state)
static Wrap | getWrapT (SoState *const state)
static Wrap | getWrapR (SoState *const state)
static SbBool | containsTransparency (SoState *const state)
| FIXME: write doc.
static const unsigned char * | getDefault (SbVec2s &size, int &numComponents)
| FIXME: write doc.
static const unsigned char * | getDefault (SbVec3s &size, int &numComponents)
Static Public Member Functions inherited from SoReplacedElement
static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void | initClass (void)
Static Public Member Functions inherited from SoElement
static void | initClass (void)
static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void | initElements (void)
static int | getNumStackIndices (void)
static SoType | getIdFromStackIndex (const int stackIndex)

## Protected Member Functions
virtual | ~SoGLTextureImageElement ()
virtual SbBool | hasTransparency (void) const
Protected Member Functions inherited from SoTextureImageElement
virtual | ~SoTextureImageElement ()
virtual void | setElt (const SbVec2s &size, const int numComponents, const unsigned char *bytes, const Wrap wrapS, const Wrap wrapT, const Model model, const SbColor &blendColor)
| FIXME: write doc.
virtual void | setElt (const SbVec3s &size, const int numComponents, const unsigned char *bytes, const Wrap wrapS, const Wrap wrapT, const Wrap wrapR, const Model model, const SbColor &blendColor)
Protected Member Functions inherited from SoReplacedElement
virtual | ~SoReplacedElement ()
Protected Member Functions inherited from SoElement
| SoElement (void)
void | capture (SoState *const state) const
virtual void | captureThis (SoState *state) const
void | setTypeId (const SoType typeId)
void | setStackIndex (const int index)
SoElement * | getNextInStack (void) const
SoElement * | getNextFree (void) const

## Additional Inherited Members
Public Types inherited from SoTextureImageElement
enum | Model { BLEND = 0x0be2, MODULATE = 0x2100, DECAL = 0x2101, REPLACE = 0x1E01 }
enum | Wrap { CLAMP = 0x2900, REPEAT = 0x2901, CLAMP_TO_BORDER = 0x812D }
Static Protected Member Functions inherited from SoReplacedElement
static SoElement * | getElement (SoState *const state, const int stackIndex, SoNode *const node)
Static Protected Member Functions inherited from SoElement
static SoElement * | getElement (SoState *const state, const int stackIndex)
static const SoElement * | getConstElement (SoState *const state, const int stackIndex)
static int | createStackIndex (const SoType id)
Protected Attributes inherited from SoTextureImageElement
SbVec3s | size
int | numComponents
const unsigned char * | bytes
Wrap | wrapS
Wrap | wrapT
Wrap | wrapR
Model | model
SbColor | blendColor
Protected Attributes inherited from SoReplacedElement
uint32_t | nodeId
Protected Attributes inherited from SoElement
SoType | typeId
int | stackIndex
int | depth
Static Protected Attributes inherited from SoElement
static int | classStackIndex
static SoTypeList * | stackToType

## Detailed Description

The SoGLTextureImageElement is used to control the current GL texture.

This is a lazy element. It is evaluated in SoShape::shouldGLRender().

## Constructor & Destructor Documentation

SoGLTextureImageElement::~SoGLTextureImageElement | ( | void |  | ) |
| protectedvirtual

The destructor.

## Member Function Documentation

void * SoGLTextureImageElement::createInstance | ( | void |  | ) |
| static

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

void SoGLTextureImageElement::initClass | ( | void |  | ) |
| static

This static method initializes static data in the SoGLTextureImageElement class.

void SoGLTextureImageElement::push | ( | SoState * | state | ) |
| virtual

This method is called every time a new element is required in one of the stacks. This happens when a writable element is requested, using SoState::getElement() or indirectly SoElement::getElement(), and the depth of the current element is less than the state depth.

Override this method if your element needs to copy data from the previous top of stack. The push() method is called on the new element, and the previous element can be found using SoElement::getNextInStack().

Reimplemented from SoElement.

void SoGLTextureImageElement::pop | ( | SoState * | state,
|  | const SoElement * | prevTopElement
| ) |  |
| virtual

This method is callled when the state is popped, and the depth of the element is bigger than the current state depth. pop() is called on the new top of stack, and a pointer to the previous top of stack is passed in prevTopElement.

Override this method if you need to copy some state information from the previous top of stack.

Reimplemented from SoElement.

void SoGLTextureImageElement::set | ( | SoState *const | stateptr,
|  | SoNode *const | node,
|  | SoGLImage * | image,
|  | const Model | model,
|  | const SbColor & | blendColor
| ) |  |
| static

Sets the current texture. Id didapply is TRUE, it is assumed that the texture image already is the current GL texture. Do not use this feature unless you know what you're doing.

int32_t SoGLTextureImageElement::getMaxGLTextureSize | ( | void |  | ) |
| static

The size returned by this function will just be a very coarse estimate as it only uses the more or less obsoleted technique of calling glGetIntegerv(GL_MAX_TEXTURE_SIZE).

For a better estimate, use SoGLTextureImageElement::isTextureSizeLegal().

Note that this function needs an OpenGL context to be made current for it to work. Without that, you will most likely get a faulty return value or even a crash.

SbBool SoGLTextureImageElement::isTextureSizeLegal | ( | int | xsize,
|  | int | ysize,
|  | int | zsize,
|  | int | bytespertexel
| ) |  |
| virtual

Returns true if the texture with the given dimensions is supported by the current OpenGL context.

If zsize==0, 2D texturing is assumed, else 3D texturing is assumed.

This function uses OpenGL proxy textures and will fall back to what you get from SoGLTextureImageElement::getMaxGLTextureSize() if proxy textures are not supported (i.e. OpenGL version < 1.1 and GL_EXT_texture not available). In the 3D case, 3D textures need to be supported (OpenGL >= 1.2 or GL_EXT_texture3D).

Note that this function needs an OpenGL context to be made current for it to work. Without that, you will most likely get a faulty return value or even a crash.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Since
  Coin 2.0

SbBool SoGLTextureImageElement::hasTransparency | ( | SoState * | state | ) |
| static

Return TRUE if at least one pixel in the current texture image is transparent.

Since
  Coin 3.1

SbBool SoGLTextureImageElement::hasTransparency | ( | void |  | ) | const
| protectedvirtual

Called by containsTransparency(). Returns TRUE if image data has transparency. Default method does a very poor job of detecting this, since it returns TRUE when the number of components are 2 or

1. Override whenever it is important to know this (SoGLTextureImageElement overrides it to avoid transparency handling where possible).

Reimplemented from SoTextureImageElement.

The documentation for this class was generated from the following files:

- SoGLTextureImageElement.h
- SoGLTextureImageElement.cpp

Copyright © 1998-2010 by Kongsberg Oil & Gas Technologies. All rights reserved.